// RsvDlg.cpp :  Դϴ.
//

#include "stdafx.h"
#include "NeMessenger.h"
#include "RsvDlg.h"

//move BTN_HEIGHT define from SendMemoButtons.h
#define BTN_HEIGHT				36

// CRsvDlg ȭ Դϴ.

IMPLEMENT_DYNAMIC(CRsvDlg, CSkinDialog)
#define TIMER_EVENT_FLASH_CAPTION_ID	(1)
#define TIMER_EVENT_FLASH_CAPTION_ELAPCE	(100)

CRsvDlg::CRsvDlg(CWnd* pParent /*=NULL*/)
	: CSkinDialog(CRsvDlg::IDD, pParent),m_bInitSucess(FALSE)
{
	 m_rcGMTTitleText.SetRect(18,39,78,57);
	 m_rcRsvTimeTitleText.SetRect(18,71,78,90);
	 m_rcGMTControl.SetRect(79,36,299,165);
	 m_rcMonthControl.SetRect(78,66,176,87);
	 m_rcHourControl.SetRect(181,67,237,86);
	 m_rcMinControl.SetRect(243,67,299,86);
	 m_rcRsvText.SetRect(18,115,300,135);
	 m_rcSendButton.SetRect(100,261,158,289);
	 m_rcCancelButton.SetRect(162,261,220,289);
	 m_nFlashTimes = 0;
	 m_pOKCancelButtons = NULL;
     //m_hWndDateTimePickerEidt = NULL;
}

CRsvDlg::~CRsvDlg()
{
}

void CRsvDlg::DoDataExchange(CDataExchange* pDX)
{
	CSkinDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_GMT_COMBO, m_cmbGMT);
	DDX_Control(pDX, IDC_RSVTIME_COMBO, m_cmbTime);
	DDX_Control(pDX, IDC_RSVMIN_COMBO, m_cmbMin);
	DDX_Control(pDX, IDC_RSV_DATETIMEPICKER, m_ctrlCal);
}


BEGIN_MESSAGE_MAP(CRsvDlg, CSkinDialog)
	ON_WM_PAINT()
	ON_WM_SIZE()
	ON_WM_CREATE()
	ON_WM_NCHITTEST()
	ON_WM_ERASEBKGND()
	ON_WM_DESTROY()
	ON_WM_NCLBUTTONDBLCLK()
	ON_WM_WINDOWPOSCHANGING()
	ON_WM_TIMER()
END_MESSAGE_MAP()


BOOL CRsvDlg::OnInitDialog()
{
	CSkinDialog::OnInitDialog();
	InitSkin();
	ModifyStyle(DS_MODALFRAME, WS_THICKFRAME);
	ModifyStyle(0, WS_CLIPCHILDREN);
	ModifyStyle(WS_MAXIMIZEBOX, 0);
	ModifyStyle(WS_MINIMIZEBOX, 0);
	CString strString;

	MoveWindow(0, 0, DEF_RSV_DLG_SIZE_CX, DEF_RSV_DLG_SIZE_CY);
	CenterWindow();

	m_cmbGMT.AddWorldTimeStrings();
	m_cmbGMT.SetCurSel(26);
	m_cmbGMT.SetDropDownResizing(FALSE);
	//m_cmbGMT.SetTextColor(SMS_RSV_VALUE_TEXT_COLOR);
	for(int i=0;i<24;i++)
	{
		CString strTime;
		strString.LoadString(IDS_STRING212);
		strTime.Format(strString, i);
		m_cmbTime.AddString(strTime);
	}

	CString strMin;
	strString.LoadString(IDS_STRING213);

	for(int i=0;i<6;i++)
	{
		strMin.Format(strString, i*10);
		m_cmbMin.AddString(strMin);
	}
	

	SetComboCurrentTime();

	m_cmbGMT.MoveWindow(m_rcGMTControl);
	GetDlgItem(IDC_RSV_DATETIMEPICKER)->MoveWindow(m_rcMonthControl);
	GetDlgItem(IDC_RSV_DATETIMEPICKER)->SetFont(&g_ftDefault9PT);


	m_cmbTime.MoveWindow(m_rcHourControl);
	//m_cmbTime.SetTextColor(SMS_RSV_VALUE_TEXT_COLOR);
	m_cmbMin.MoveWindow(m_rcMinControl);
	//m_cmbMin.SetTextColor(SMS_RSV_VALUE_TEXT_COLOR);
	__ResourceLoad(TRUE);

	ResizeControl();
	m_bInitSucess=TRUE;
	return TRUE;
}

// CRsvDlg ޽ óԴϴ.

void CRsvDlg::OnBnClickedConfirmButton()
{	
	if(!GetReservationTime(m_strRsvTime,m_strTimeZone))
	{
		NMessageBox(this, LoadStringFromResource(IDS_STRING468));
		return;
	}

	CSkinDialog::OnOK();
}

void CRsvDlg::OnBnClickedCancelButton()
{	
	CSkinDialog::OnCancel();
}

void CRsvDlg::OnPaint()
{
	CPaintDC dc(this); 
}


LRESULT CRsvDlg::OnNcHitTest(CPoint point)
{
	return HTCAPTION;
}

void CRsvDlg::__ResourceLoad(BOOL bInit /* = FALSE */)
{
	CString strTitle = LoadStringFromResource(IDS_STRING533);
	SetWindowText(strTitle);
	SetDialogShowWindowText(true);
	SetDialogWindowText(strTitle);
	SetWindowTextColor(CColorConvert::HEX2Color(0xFFC8D1D8));
	SetWindowTextFontHeight(12);
	SetShowTitle(FALSE);
	if(bInit)
	{
		SetLeftTopPNG(GetAppImgFile(_T("img_title_l.png")));
		SetCenterTopPNG(GetAppImgFile(_T("img_title_c.png")));
		SetRightTopPNG(GetAppImgFile(_T("img_title_r.png")));

		SetLeftBorderBitmap(GetAppImgFile(_T("new_02_left.bmp")));
		SetRightBorderBitmap(GetAppImgFile(_T("new_02_right.bmp")));

		SetLeftBottomPNG(GetAppImgFile(_T("img_bottom_l.png")));
		SetCenterBottomPNG(GetAppImgFile(_T("img_bottom_c.png")));
		SetRightBottomPNG(GetAppImgFile(_T("img_bottom_r.png")));
		//SetUserBottomPNGBK(GetAppImgFile(_T("btn_popup_org_c_nor.png")));
		//SetUserBottomPNG(GetAppImgFile(_T("btn_popup_org_bar.png")));

		SetUserBottomPNGBK(GetAppImgFile(_T("btn_popup_org_c_nor.png")));
		SetUserBottomPNG(GetAppImgFile(_T("btn_popup_org_bar.png")));

		SetExitBitmaps(GetAppImgFile(_T("btn_common_cancel_nor.bmp")),
			GetAppImgFile(_T("btn_common_cancel_foc.bmp")), GetAppImgFile(_T("btn_common_cancel_pre.bmp")));
		SetCloseEvent(TRUE);
	}
}

void CRsvDlg::SetComboCurrentTime() 
{
	SYSTEMTIME stCurrentTime;
	GetLocalTime(&stCurrentTime);

	if (stCurrentTime.wMinute >= 50)
	{
		m_cmbTime.SetCurSel(stCurrentTime.wHour + 1);
		m_cmbMin.SetCurSel(0);
		
	}
	else
	{
		m_cmbTime.SetCurSel(stCurrentTime.wHour);
		m_cmbMin.SetCurSel(((int)(stCurrentTime.wMinute /10)) +1);
	}
}
void CRsvDlg::InitSkin()
{
	TCHAR szStylesPath[_MAX_PATH];

	VERIFY(::GetModuleFileName(AfxGetApp()->m_hInstance, szStylesPath, _MAX_PATH));

	CString strStylesPath = szStylesPath;
	int nIndex  = strStylesPath.ReverseFind(_T('\\'));
	if (nIndex > 0) 
	{
		strStylesPath = strStylesPath.Left(nIndex);
	}
	else 
	{
		strStylesPath.Empty();
	}
	strStylesPath += _T("\\IMAGES\\style\\");

	CXTPSkinManager* pSkinManager = XTPSkinManager();

	// LosdSkin()   ׸    .
	//  ׸ ϱ ؼ SetWindowsTheme  ̿ؾ .
	pSkinManager->ApplyWindow(GetSafeHwnd());
	CXTPSkinManagerSchema* pSchema = pSkinManager->CreateSchema(GetAppImgDir()+_T("\\style\\Ntalk.cjstyles"), _T("Base1.ini"));
	pSkinManager->SetWindowTheme(GetSafeHwnd(), pSchema);
	CMDTARGET_RELEASE(pSchema);
}

BOOL CRsvDlg::OnEraseBkgnd(CDC* pDC)
{
	CRect rcClient(0, 0, 0, 0);
	GetClientRect(rcClient);
	//pDC->FillSolidRect(rcClient,SMS_RSV_BG_COLOR);
	//pDC->FillSolidRect(0,0,DEF_RSV_DLG_SIZE_CX,SMS_RSV_BORDER_PIXEL,SMS_RSV_CONTROL_BORDER_COLOR);
	//pDC->FillSolidRect(0,rcClient.bottom - 55,DEF_RSV_DLG_SIZE_CX,SMS_RSV_BORDER_PIXEL,SMS_RSV_CONTROL_BORDER_COLOR);

	CFont *pOldFont = pDC->SelectObject(&g_ftDefault9PTB);
	COLORREF oldColor = pDC->SetTextColor(SMS_RSV_TITLE_TEXT_COLOR);
	pDC->SetBkMode(TRANSPARENT);
	pDC->DrawText(LoadStringFromResource(IDS_STRING554),m_rcGMTTitleText,DT_LEFT);
	pDC->DrawText(LoadStringFromResource(IDS_STRING555),m_rcRsvTimeTitleText,DT_LEFT);
	pDC->SelectObject(pOldFont);

	
	pDC->SetTextColor(oldColor);
	oldColor = pDC->SetTextColor(SMS_RSV_VALUE_TEXT_COLOR);
	pOldFont = pDC->SelectObject(&g_ftDefault9PT);
	UpdateData(TRUE);
	SYSTEMTIME stReservationTime;
	SYSTEMTIME stCurrentTime;
	GetLocalTime(&stCurrentTime);
	((CDateTimeCtrl*) (GetDlgItem(IDC_RSV_DATETIMEPICKER)))->GetTime(&stReservationTime); 
	stReservationTime.wHour =m_cmbTime.GetCurSel();
	stReservationTime.wMinute = m_cmbMin.GetCurSel() * 10 ;

	FILETIME ftReservationTime, ftCurrentTime;
	SystemTimeToFileTime(&stReservationTime, &ftReservationTime);
	SystemTimeToFileTime(&stCurrentTime, &ftCurrentTime);
	if(CompareFileTime(&ftReservationTime,&ftCurrentTime)<0)
	{
		
	}

	CString strTimeZone;
	int index = m_cmbGMT.GetCurSel();
	m_cmbGMT.GetLBText(index, strTimeZone);
	CString strRsv;
	CRect rcText(0, 0, 0, 0);
    rcText.SetRect(rcClient.left,130,rcClient.right,230);
	pDC->DrawText(LoadStringFromResource(IDS_STRING633), rcText,DT_CENTER);


	CWnd* pChild=GetWindow(GW_CHILD);
	while(pChild)
	{
		if(pChild->IsKindOf(RUNTIME_CLASS(CEdit)) || pChild->IsKindOf(RUNTIME_CLASS(CRichEditCtrl)) ||pChild->IsKindOf(RUNTIME_CLASS(CListCtrl)) || pChild->IsKindOf(RUNTIME_CLASS(CComboBox))||pChild->IsKindOf(RUNTIME_CLASS(CSpinButtonCtrl)))
		{
			if(pChild->IsWindowVisible())
			{
				CRect rcEdit(0, 0, 0, 0);
				pChild->GetWindowRect(rcEdit);
				ScreenToClient(rcEdit);

				rcEdit.InflateRect(1,1);
				rcEdit.OffsetRect(0, 0);
				CPen penEditBox;
				penEditBox.CreatePen(PS_SOLID,1,SMS_RSV_CONTROL_BORDER_COLOR);
				CPen *pOldPen= pDC->SelectObject(&penEditBox);
				pDC->Rectangle(rcEdit);
				pDC->SelectObject(pOldPen);
			}
		}

		pChild=pChild->GetWindow(GW_HWNDNEXT);
	}
	pDC->SetTextColor(oldColor);	
	pDC->SelectObject(pOldFont);
	return TRUE;
}

BOOL CRsvDlg::PreTranslateMessage(MSG* pMsg)
{

	if(pMsg->message == WM_KEYDOWN)
	{
		if(pMsg->wParam == VK_RETURN)
		{
			OnBnClickedConfirmButton();
		}
		else if (pMsg->wParam == VK_ESCAPE)
		{
			OnCancel();
		}
			return TRUE;
	}

	else if(pMsg->message == WM_NCLBUTTONDBLCLK)
	{
		return TRUE;
	}

	return __super::PreTranslateMessage(pMsg);
}



BOOL CRsvDlg::GetReservationTime(CString &strTime, CString &strTimeZone)
{
		UpdateData(TRUE);
		SYSTEMTIME stReservationTime;
		SYSTEMTIME stCurrentTime;
		GetLocalTime(&stCurrentTime);
		((CDateTimeCtrl*) (GetDlgItem(IDC_RSV_DATETIMEPICKER)))->GetTime(&stReservationTime); 
		stReservationTime.wHour =m_cmbTime.GetCurSel();
		stReservationTime.wMinute = m_cmbMin.GetCurSel() * 10 ;

		FILETIME ftReservationTime, ftCurrentTime;
		SystemTimeToFileTime(&stReservationTime, &ftReservationTime);
		SystemTimeToFileTime(&stCurrentTime, &ftCurrentTime);
		if(CompareFileTime(&ftReservationTime,&ftCurrentTime)<0)
		{
			return FALSE;
		}


		// ߼ Ex) 2011-12-28 15:51:10
		strTime.Format(_T("%d-%02d-%02d %02d:%02d:00"),
			stReservationTime.wYear,
			stReservationTime.wMonth,
			stReservationTime.wDay,
			m_cmbTime.GetCurSel(),
			m_cmbMin.GetCurSel() * 10);

		int index = m_cmbGMT.GetCurSel();
		strTimeZone = m_cmbGMT.GetWorldTimeString(index);
		return TRUE;
}

const CString CRsvDlg::GetReservationTimeString()
{
	CString strReturn = L"NULL";
	UpdateData(TRUE);
	SYSTEMTIME stReservationTime;
	((CDateTimeCtrl*) (GetDlgItem(IDC_RSV_DATETIMEPICKER)))->GetTime(&stReservationTime); 
	stReservationTime.wHour =m_cmbTime.GetCurSel();
	stReservationTime.wMinute = m_cmbMin.GetCurSel() * 10 ;

	FILETIME ftReservationTime;
	SystemTimeToFileTime(&stReservationTime, &ftReservationTime);


	// ߼ Ex) 2011-12-28 15:51:10
	strReturn.Format(LoadStringFromResource(IDS_STRING557),
		stReservationTime.wYear,
		stReservationTime.wMonth,
		stReservationTime.wDay,
		m_cmbTime.GetCurSel(),
		m_cmbMin.GetCurSel() * 10);
	return strReturn;
}

void CRsvDlg::OnNcLButtonDblClk( UINT nHitTest, CPoint point )
{
	/*if (!IsZoomed())
	{
		::ShowWindow(m_hWnd, SW_SHOWMAXIMIZED);
	}
	else
	{
		::ShowWindow(m_hWnd, SW_SHOWNOACTIVATE);
	}
*/

}

void CRsvDlg::OnSize( UINT nType, int cx, int cy )
{
	__super::OnSize(nType, cx, cy);

	ResizeControl();
	::RedrawWindow(GetSafeHwnd(), NULL, NULL, RDW_ERASE | RDW_INVALIDATE | RDW_FRAME | RDW_ALLCHILDREN);
}

void CRsvDlg::OnDestroy()
{
	if(m_pOKCancelButtons)
	{
		::DestroyWindow(m_pOKCancelButtons->GetHWND());
		SAFE_DELETE(m_pOKCancelButtons);
	}

	CSkinDialog::OnDestroy();
}

void CRsvDlg::ResizeControl()
{
	if(m_pOKCancelButtons && m_pOKCancelButtons->GetHWND())
	{
		CRect rcClient(0, 0, 0, 0);
		GetClientRect(&rcClient);
		CRect rcButtons(rcClient.left + 5, rcClient.bottom+5 - BTN_HEIGHT, rcClient.right - 5, rcClient.bottom + 5);
		m_pOKCancelButtons->SetClientRect(rcButtons);
	}
}

void CRsvDlg::OnButtonClicked( COKCancelButtons::BUTTONS button )
{
	ASSERT(button != COKCancelButtons::All);

	if(button == COKCancelButtons::Cancle)
	{
		OnBnClickedCancelButton();
	}

	if(button == COKCancelButtons::OK)
	{
		OnBnClickedConfirmButton();
	}
}

int CRsvDlg::OnCreate( LPCREATESTRUCT lpCreateStruct )
{
	if (CSkinDialog::OnCreate(lpCreateStruct) == -1)
		return -1;


	m_pOKCancelButtons = new COKCancelButtons(this, this);
	m_pOKCancelButtons->LoadSkin();
	m_pOKCancelButtons->SetButtonText(LoadStringFromResource(IDS_STRING568),
		LoadStringFromResource(IDS_STRING569));

	return 0;
}


void CRsvDlg::FlashCaption()
{
	SetTimer(TIMER_EVENT_FLASH_CAPTION_ID, TIMER_EVENT_FLASH_CAPTION_ELAPCE, NULL);
}

void CRsvDlg::OnTimer( UINT_PTR nIDEvent )
{
	if(nIDEvent == TIMER_EVENT_FLASH_CAPTION_ID)
	{
		if (m_nFlashTimes > 10)
		{
			KillTimer(nIDEvent);
			SetDialogWindowText(LoadStringFromResource(IDS_STRING533));
			m_nFlashTimes = 0;

			return;
		}
		CString strText = GetDialogWindowText();
		if (!strText.IsEmpty())
		{
			SetDialogWindowText(_T(""));
		}
		else
		{
			SetDialogWindowText(LoadStringFromResource(IDS_STRING533));
		}
		m_nFlashTimes++;
	}
}

void CRsvDlg::OnWindowPosChanging( LPWINDOWPOS lpWndPos )
{
	WINDOWPOS wp = *lpWndPos;
	UINT flags = SWP_NOACTIVATE | SWP_NOSIZE | SWP_NOMOVE;
	CPoint pt(0, 0);
	GetCursorPos(&pt);
	CRect rcParentWnd(0, 0, 0, 0);
	CRect rcWnd(0, 0, 0, 0);
	HWND hParentWnd = ::GetParent(m_hWnd);
	ASSERT(hParentWnd);
	if(NULL == hParentWnd)
	{
		return;
	}

	HWND hWndFocus = ::GetForegroundWindow();
	::GetWindowRect(hParentWnd, rcParentWnd);
	GetWindowRect(&rcWnd);
	CString str ;
	str.Format(_T("%d"), wp.flags );
	OutputDebugString(str);
	if ((wp.flags == flags) && rcParentWnd.PtInRect(pt) 
		&& !rcWnd.PtInRect(pt) && (m_hWnd == hWndFocus))
	{
		FlashCaption();
	}
}
